package com.nokia.mj.impl.test.jvmporttest2;

import com.nokia.mj.impl.rt.support.restricted.RestrictedTest;
import com.nokia.mj.impl.rt.support.restricted.RestrictedClass;
import com.nokia.mj.impl.rt.support.restricted.RestrictedClass2;


public class TestClass implements javax.microedition.rms.RecordComparator
{
    public int compare(byte[] rec1,
                       byte[] rec2)
    {
        if (rec1 == null && rec2 == null)
        {
            return 43;
        }
        else if (rec2 == null)
        {
            int failedCount = 0;
            failedCount += instantiatePlatformRestricedClass();
            try
            {
                try
                {
                    RestrictedClass rt = (RestrictedClass)Class.forName("com.nokia.mj.impl.rt.support.restricted.RestrictedClass").newInstance();
                    System.err.println("Call to restricted pakage should have failed: " + rt);
                    failedCount++;
                }
                catch (Throwable t)
                {
                    if (t.toString().indexOf("java.lang.SecurityException") == -1)
                    {
                        throw t;
                    }
                }

                try
                {
                    int res = new RestrictedClass().getValue();
                    System.err.println("Call to restricted pakage should have failed2: " + res);
                    failedCount++;
                }
                catch (Throwable t)
                {
                    if (t.toString().indexOf("java.lang.SecurityException") == -1)
                    {
                        throw t;
                    }
                }
            }
            catch (Throwable t)
            {
                System.err.println("Failure " + t);
                t.printStackTrace();
                return -1;
            }
            return failedCount;
        }

        else
        {
            int failedCount = 0;
            failedCount += instantiatePlatformRestricedClass();
            try
            {
                RestrictedClass2 rt = (RestrictedClass2)Class.forName("com.nokia.mj.impl.rt.support.restricted.RestrictedClass2").newInstance();
                int res = rt.getValue();
                if (res != 45)
                {
                    failedCount++;
                    System.err.println("RestrictedClass2: Class.forName failed (wrong result): " + res);
                }
                res = new RestrictedClass2().getValue();
                if (res != 45)
                {
                    failedCount++;
                    System.err.println("RestrictedClass2: new RestrictedClass2() failed (wrong result): " + res);
                }
            }
            catch (Throwable t)
            {
                System.err.println("Failure " + t);
                return -1;
            }
            return failedCount;
        }
    }

    private int instantiatePlatformRestricedClass()
    {
        int failedCount = 0;
        try
        {
            RestrictedTest rt = (RestrictedTest)Class.forName("com.nokia.mj.impl.rt.support.restricted.RestrictedTest").newInstance();
            int res = rt.getValue();
            if (res != 11)
            {
                failedCount++;
                System.err.println("instantiatePlatformRestricedClass: Class.forName failed (wrong result): " + res);
            }
        }
        catch (Throwable t)
        {
            System.err.println("instantiatePlatformRestricedClass: Class.forName failed: " + t);
            failedCount++;
        }

        try
        {
            RestrictedTest rt = new RestrictedTest();
            int res = rt.getValue();
            if (res != 11)
            {
                failedCount++;
                System.err.println("instantiatePlatformRestricedClass: new RestrictedTest() (wrong result): " + res);
            }
        }
        catch (Throwable t)
        {
            System.err.println("instantiatePlatformRestricedClass: new RestrictedTest() failed: " + t);
            failedCount++;
        }
        return failedCount;
    }
}